<?php

// TODO: file and class name must have the same name as project

class Theme_bocian extends ThemeDefault {

	function head() {
		// echo ''; // TODO: dodać bootsrap-theme-bocian
		echo '<meta name="robots" content="noindex, nofollow">';
		UI::inlineCSS(dirname(__FILE__) . '/assets/css/styles.css');
		echo UI::h('style', [ 'type' => "text/css" ], "
			.AjaxTable { font-size:14px }
			.AjaxTable .tblAjax__head__filter .stickyCol1 button { padding:1px 3px }
			.AjaxTable tbody .stickyCol1 { font-size:12px }
			.popover-content li { text-align:left; font-size:14px }
		");
	}


	function top() {
		include dirname(__FILE__) . '/view/top.php';
		//todo: demo load data for graph :DELETE line if tested
		// UI::inlineRawJS(dirname(__FILE__) . '/demoGraph/sampleData/sampleData.js');
		// UI::inlineRawJS(dirname(__FILE__) . '/assets/js/graph/GetFeature.js');
		// UI::inlineRawJS(dirname(__FILE__) . '/assets/js/graph/parser.js');
	}

	function footer() {
		include dirname(__FILE__) . '/view/footer.php';
		//todo: ujednolicic wczytanie themy widoków i css w jednym katalogu(obecnie css w katalogu static a widoki w katalogu tmp )
		UI::inlineRawJS(dirname(__FILE__) . '/assets/js/scripts.js');

		if ('ViewTableAjax' === V::get('_route', '', $_GET)
			&& 'default_db/BI_audit_ENERGA_RUM_KONTRAHENCI_POWIAZANIA/BI_audit_ENERGA_RUM_KONTRAHENCI_POWIAZANIA' === V::get('namespace', '', $_GET)
		) {
			UI::inlineJS(dirname(__FILE__) . '/assets/js/updateRaportProgress.js', [
				'DBG' => (V::get('DBG', '', $_GET)),
				'DBG_FAKE_ANIM' => (V::get('DBG_FAKE_ANIM', '', $_GET)),
				'URL_FETCH_BI_AUDIT_PROGRESS' => Router::getRoute('UrlAction_Bocian')->getLink('fetchProgressAjax')
			]);
		}
		// graph lib
		UI::inlineRawJS(dirname(__FILE__) . '/assets/js/graph/d3.v3.min.js');
		UI::inlineRawJS(dirname(__FILE__) . '/assets/js/graph/csaladenes/sankey/sankey.js');
		// UI::inlineRawJS(dirname(__FILE__) . '/assets/js/graph/csaladenes/sankey/sankey-init.js');
		UI::inlineRawJS(dirname(__FILE__) . '/assets/js/graph/sankey-init-widget.js');
	}

	function login($data) {
		if (is_array($data) && !empty($data)) {
			extract($data);
		}
		include dirname(__FILE__) . '/view/login.php';
	}

	function logout($data) {
		if (is_array($data) && !empty($data)) {
			extract($data);
		}
		include dirname(__FILE__) . '/view/logout.php';
	}

	function home($data) {
		if (is_array($data) && !empty($data)) {
			extract($data);
		}
		include dirname(__FILE__) . '/view/home.php';
	}

}
